image: ruby:2.5

variables:
  DEBIAN_FRONTEND: "noninteractive"
  KITCHEN_YAML: ".kitchen.ci.yml"
  BUNDLE_PATH: "$CI_PROJECT_DIR/.bundle"
  DIGITALOCEAN_TESTBOX_FQDN: "template.${CI_PROJECT_NAMESPACE}.ci.gitlab.test"

stages:
  - test
  - publish

before_script:
  - eval $(ssh-agent -s)
  - ssh-add <(echo $CI_PRIVATE_KEY |base64 -d)
  - mkdir -p ~/.ssh
  - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
  - apt-get -qq update && apt-get -yqq install openssh-client rsync make jq
  - bundle install

rspec-test-job:
  stage: test
  coverage: /^\s*Touch\sCoverage:\s*(\d+\.\d+)%/
  script:
    - bundle exec rspec
  only:
    variables:
      - $CI_PRIVATE_KEY

cookstyle-test-job:
  stage: test
  coverage: /^\s*Touch\sCoverage:\s*(\d+\.\d+)%/
  script:
    - bundle exec cookstyle
  only:
    variables:
      - $CI_PRIVATE_KEY

kitchen-test-job:
   stage: test
   cache:
     paths:
       - $BUNDLE_PATH
   script:
     - make kitchen
   only:
     variables:
       - $CI_PRIVATE_KEY

push-cookbook:
  stage: publish
  only:
    refs:
      - master
    variables:
      - $OPS_CLONE_USERNAME
      - $OPS_CLONE_PASSWORD
  script:
    - git clone https://$OPS_CLONE_USERNAME:$OPS_CLONE_PASSWORD@ops.gitlab.net/gitlab-cookbooks/cookbook-publisher.git /tmp/cookbook-publisher
    - cp /tmp/cookbook-publisher/publisher.rb .
    - ruby publisher.rb
